不思议棋牌网址 当前位置:首页>不思议棋牌网址>正文

不思议棋牌网址

发布时间:2018-11-13

原标题:java中的异常处理

钱诺心中思忖道:“清虚大帝果然是厉害。”立刻不再有所保留,手中飞出了那柄纪太虚炼制的长剑,对着清虚大帝一劈,便见一道仿若是黑色火焰一般的剑气朝着清虚大帝轰去。清虚大帝眼中精光一闪,手中的神斧一晃,便见到一道罡气从神斧之上飞出,将这道黑色火焰一般的剑气给击散,成了无边的流光。

att版se

他或许已经习惯了,这个世界本就是有着势力的人才能够高人一等,而像他这样子的人,只能在底层打拼,靠着学习和成绩一步一步攀爬!别人强大的世家随便就可以给自己的子孙安排一个地位,而底层的人员却需要奋斗和努力……
那人冷笑,“一旦明王令到手,王爷岂能容我在此放肆。”说完手中酒杯顺势一扬,里面半碗酒洒了一地。

这头人面魔蛛就成为了唐三第一个实验品,急速生长起来的巨大蓝银草一边阻拦着它前进的脚步,一边疯狂的发动着一个又一个的缠绕技能。唐三和它之间的距离越近,蓝银草的反应就越疯狂。

一:异常的概念:

  Java把异常当作对象来处理,并定义一个基类java.lang.Throwable作为所有异常的超类。
 在Java API中已经定义了许多异常类,这些异常类分为两大类,错误Error和异常Exception。

我们先查看一下异常类的树状体系结构,如下:

 

 

 

 

Thorwable类所有异常和错误的超类,有两个子类Error和Exception,分别表示错误和异常。其中异常类Exception又分为运行时异常(RuntimeException)和非运行时异常, 这两种异常有很大的区别,也称之为不检查异常(Unchecked Exception) 和检查异常(Checked Exception)。

 

1:Error和Exception

Error是程序无法处理的错误,比如OutOfMemoryError、ThreadDeath等。这些异常发生时,  Java虚拟机(JVM)一般会选择线程终止。


Exception是程序本身可以处理的异常,这种异常分两大类运行时异常(不可查异常)和非运行时异常(可查异常)。 程序中应当尽可能去处理这些异常。

 

2:运行时异常和非运行时异常

 运行时异常都是RuntimeException类及其子类异常,如NullPointerException、IndexOutOfBoundsException等, 这些异常是不检查异常,程序中可以选择捕获处理,也可以不处理。这些异常一般是由程序逻辑错误引起的, 程序应该从逻辑角度尽可能避免这类异常的发生。

这类异常程序不要求必须去做处理。


非运行时异常是RuntimeException以外的异常,类型上都属于Exception类及其子类。 从程序语法角度讲是必须进行处理的异常,如果不处理,程序就不能编译通过。 如IOException、SQLException等以及用户自定义的Exception异常,一般情况下不自定义检查异常。

这类异常则要求我们对这个异常进行处理,要么使用try--catch--finally,要么使用throws去声明这个异常。

二:异常的处理:

 首先在java中,都是通过 try--catch--finally,throw,throws关键字进行的。

 

1:异常处理的基本语法:

 

try--catch--finally:

 1 package Enum;
 2 
 3 public  class MyClass{
 4     public static void main(String[] args) {
 5         try {
 6             //可能会出现异常的代码块
 7         } catch (Exception e) {//想要捕获的异常
 8             //异常的处理
 9             e.printStackTrace();
10         }finally{
11             //不管怎样都会被运行的语句,例如关闭链接资源,关闭连接对象
12         }
13     }
14 }

 

1: try语句块,表示要尝试运行代码,try语句块中代码受异常监控,其中代码发生异常时,会抛出异常对象。 

catch语句块会捕获try代码块中发生的异常并在其代码块中做异常处理,catch语句带一个Throwable类型的参数, 表示可捕获异常类型。当try中出现异常时,catch会捕获到发生的异常,并和自己的异常类型匹配, 若匹配,则执行catch块中代码,并将catch块参数指向所抛的异常对象。catch语句可以有多个,  用来匹配多个中的一个异常,一旦匹配上后,就不再尝试匹配别的catch块了,所以如果需要匹配多个异常就把异常的子类放到前面,父类放到后面。 通过异常对象可以获取异常发生时完整的JVM堆栈信息,以及异常信息和异常发生的原因等。

 finally语句块是紧跟catch语句后的语句块,这个语句块总是会在方法返回前执行,  而不管是否try语句块是否发生异常。并且这个语句块总是在方法返回前执行。 目的是给程序一个补救的机会。这样做也体现了Java语言的健壮性。

 

2、 try、catch、finally三个语句块应注意的问题 :
    第一、try、catch、finally三个语句块均不能单独使用,三者可以组成 try...catch...finally、try...catch、
    try...finally三种结构,catch语句可以有一个或多个,finally语句最多一个。
    第二、try、catch、finally三个代码块中变量的作用域为代码块内部,分别独立而不能相互访问。
    如果要在三个块中都可以访问,则需要将变量定义到这些块的外面。
    第三、多个catch块时候,只会匹配其中一个异常类并执行catch块代码,而不会再执行别的catch块,
    并且匹配catch语句的顺序是由上到下。

 

 

throw、throws关键字

 throw关键字是用于方法体内部,用来抛出一个Throwable类型的异常。如果抛出了检查异常, 则还应该在方法头部声明方法可能抛出的异常类型。该方法的调用者也必须检查处理抛出的异常。 如果所有方法都层层上抛获取的异常,最终JVM会进行处理,处理也很简单,就是打印异常消息和堆栈信息。 如果抛出的是Error或RuntimeException,则该方法的调用者可选择处理该异常。有关异常的转译会在下面说明。

throws关键字用于方法体外部的方法声明部分,用来声明方法可能会抛出某些异常。仅当抛出了检查异常, 该方法的调用者才必须处理或者重新抛出该异常。当方法的调用者无力处理该异常的时候,应该继续抛出。

 

 例如throws申明一个异常:

 1 public void test() throws ClassNotFoundException{

3 } 

 

 例如这个throw 观察一下有什么不同:

 1 public void test() throws ClassNotFoundException {
 2     throw new ClassNotFoundException();
 3     
 4     }
 5 
 6 
 7 
 8 
 9 
10 public void test() {
11         throw new RuntimeException();
12     
13     }

这很好的说明了 throw对与可查异常和不可查异常处理之间的差别

 

 

 Throwable类中的常用方法
      getCause():返回抛出异常的原因。如果 cause 不存在或未知,则返回 null。
      getMessage():返回异常的消息信息。
      printStackTrace():对象的堆栈跟踪输出至错误输出流,作为字段 System.err 的值。

 1 public  class MyClass{
 2     public static void main(String[] args) {
 3         
 4         try {
 5             
 6         } catch (Exception e) {
 7             // TODO: handle exception
 8             e.printStackTrace();
 9             e.getMessage();
10             e.getCause();
11             
12         }
13     }
14     

 

 三:异常的一般原则:

 1、 能处理就早处理,抛出不去还不能处理的就想法消化掉或者转换为RuntimeException处理。
    因为对于一个应用系统来说,抛出大量异常是有问题的,应该从程序开发角度尽可能的控制异常发生的可能。
 2、 对于检查异常,如果不能行之有效的处理,还不如转换为RuntimeException抛出。
    这样也让上层的代码有选择的余地――可处理也可不处理。
 3、 对于一个应用系统来说,应该有自己的一套异常处理框架,这样当异常发生时,也能得到统一的处理风格,
    将优雅的异常信息反馈给用户。

 

 :自定义异常:

 首先 创建一个类继承异常类,代码如下:

 1 package Exection;
 2 
 3 public class Myexecption extends Exception{
 4 
 5     public Myexecption() {
 6         super();
 7         // TODO Auto-generated constructor stub
 8     }
 9 
10     public Myexecption(String message, Throwable cause, boolean enableSuppression, boolean writableStackTrace) {
11         super(message, cause, enableSuppression, writableStackTrace);
12         // TODO Auto-generated constructor stub
13     }
14 
15     public Myexecption(String message, Throwable cause) {
16         super(message, cause);
17         // TODO Auto-generated constructor stub
18     }
19 
20     public Myexecption(String message) {
21         super(message);
22         // TODO Auto-generated constructor stub
23     }
24 
25     public Myexecption(Throwable cause) {
26         super(cause);
27         // TODO Auto-generated constructor stub
28     }
29     
30 }

 

 然后编写代码 ,然后编写逻辑,这个异常什么时候需要使用,

 1 package Exection;
 2 
 3 public class Test {
 4     public static  int shang (int x,int y) throws Myexecption{
 5          if(y==0)  
 6             {  
 7                 throw new Myexecption("您输入的是"+y+",规定除数不能为负数!");//抛出异常  
 8             }  
 9         return x/y;
10     }
11     
12     public static void main(String[] args) throws Myexecption {
13         shang(10, 0);
14     }
15 }

 

 在需要的地方抛出这个异常。

运行结果如下:

好了  异常就到这了;

 

编辑:帝密辛北

发布时间:2018-11-13 05:06:55

当前文章:http://radiokey.biz/content/2018-10-21/88761.html

ck棋牌官网 qq麻将手机版官方下载 比卡熊亲朋充值中心 吉祥棋牌ios 聚落棋牌游戏下载平台 手机麻将手机版哪个好 信誉好棋牌评测 众博棋牌唯一官网

36410 30002 61847 27540 40730 6061949002 80734 59619

责任编辑:安道密